// , ,        (-   ,  OptParamCount)
#include     "GAModule.mqh"
#include     "MustHave.mqh"
//  ,   ,          ,...
//...      StratCount
#include     "StrategyMA.mqh"                                        // 0 -  
#include     "StrategySAR.mqh"                                       // 1 -  SAR
#include     "StrategyStoch.mqh"                                     // 2 - 

input double trainDD=0.5;                                            //     
input double maxDD=0.2;                                              // ,       
int          StratCount=2;                                           //    
int          OptParamCount=5;                                        //-   
int          strat=0;                                                //  ,...
                                                                     //...-    ( 0 - )
string       s="EURUSD";                                             //  ,...
                                                                     //...         ( EURUSD)
double       optF=0.3;                                               //     ,...
                                                                     //...             ( 0.3)
bool         trig=false;                                             //   (true -   )

int OnInit()
{
  tf=Period();                                                       //       
  prevBT[0]=D'2001.01.01';                                           //  ...
  TimeToStruct(prevBT[0],prevT);                                     //...   
  depth=10000;                                                       //  (,      )
  count=2;                                                           //    (,      )
  InitArrays();                                                      //  ,    
//       
  OnInitMA();                                                        //  
  OnInitSAR();                                                       //  SAR
  OnInitStoch();                                                     //  
  GA();                                                              //   
  GetTrainResults();                                                 //    
  InitRelDD();                                                       //     
  return(0);
}

void OnDeinit(const int reason)
{
}

void OnTrade()
{
}

void OnTick()
{
  if(isNewBars()==true)
  {
    trig=false;
    switch(strat)
    {
      case  0: {trig=NeedCloseMA()   ; break;};                      //  case     
      case  1: {trig=NeedCloseSAR()  ; break;};
      case  2: {trig=NeedCloseStoch(); break;};
      default: {trig=NeedCloseMA()   ; break;};
    }
    if(trig==true)
    {
      if(GetRelDD()>maxDD)                                           //    :
      {
        GA();                                                        //   
        GetTrainResults();                                           //  
        maxBalance=AccountInfoDouble(ACCOUNT_BALANCE);               //        ,...
                                                                     //...   
      }
    }
    switch(strat)
    {
      case  0: {trig=NeedOpenMA()   ; break;};                       //  case     
      case  1: {trig=NeedOpenSAR()  ; break;};
      case  2: {trig=NeedOpenStoch(); break;};
      default: {trig=NeedOpenMA()   ; break;};
    }
    Print(TimeToString(TimeCurrent()),";","Main:OnTick:isNewBars(true)",
          ";","strat=",strat);
  }
}